unit YugenMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, System.UITypes, System.Types, Vcl.Buttons;

type
  TForm1 = class(TForm)
    Image1: TImage;
    OpenBtn: TButton;
    OpenDialog1: TOpenDialog;
    XNEdit: TLabeledEdit;
    YNEdit: TLabeledEdit;
    GridBtn: TButton;
    Checklabel: TLabel;
    PaintBtn: TButton;
    LineBackBtn: TButton;
    EleChBtn: TButton;
    LineBtn: TButton;
    LineColorEdit: TLabeledEdit;
    ClchangeBtn: TButton;
    InoutChkBtn: TButton;
    SaveDialog1: TSaveDialog;
    Savebtn: TButton;
    keisuEdit: TLabeledEdit;
    RedrowBtn: TBitBtn;
    MLabel: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure GridBtnClick(Sender: TObject);
    procedure Image1MouseEnter(Sender: TObject);
    procedure Image1MouseLeave(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure PaintBtnClick(Sender: TObject);
    procedure LineBackBtnClick(Sender: TObject);
    procedure EleChBtnClick(Sender: TObject);
    procedure LineBtnClick(Sender: TObject);
    procedure ClchangeBtnClick(Sender: TObject);
    procedure InoutChkBtnClick(Sender: TObject);
    procedure SavebtnClick(Sender: TObject);
    procedure RedrowBtnClick(Sender: TObject);
  private
    { Private 錾 }
    procedure EleOut;                   // vf}
    procedure FlowOut;                  // }
    procedure SetArrayLengthA;          // zm A
    procedure SetArrayLengthB;          // zm B
    procedure XYPosMake;                // }pW쐬@}
    procedure FemCalc;                  // FemvZ
    procedure MainCalc;                 // MainvZ
    procedure GraphClear;               // OtNA
    procedure GridMake;                 // Obh}
    procedure PosCheck(var X, Y: integer);   // ObhWmF
    procedure ElementCheck;             // vf̓`FbN
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
  BackMax     = 1000;
  PaintColor  = clMoneyGreen;
  Keyname     = 'UGEN';
//  BackMax = 5;
var
  F1      :   textFile;
  NP, NE  :   Integer;                    // ߓ_@vf
  FNX     :   array of array of Double;   // }pXW
  FNY     :   array of array of Double;   // }pYW
  X, Y    :   array of Double;            // ߓ_@wW xW
  P, SA   :   array of Double;            // ߓ_|eV()@vfW ʐς̓{
  K       :   array of array of Double;   // }bgbNX
  IP      :   array of array of Integer;  // vf̐ߓ_ԍ
  A, B    :   array of array of Double;   // w  Y
  IB      :   array of Integer;           // Œ_̐ߓ_ԍ
  PB      :   array of Double;            // Œ_̉׏d ()
  IOV     :   array of array of Integer;  // Eӏߓ_ԍ
  IOF     :   array of Double;            // Eӂ̉׏d()
  XYPos   :   array of array of array of integer;  // wxObhW
  X0, Y0  :   Integer;              // }_
  S       :   Double;               // }W
  SX, SY  :   Double;               // ʕ\W
  FixN    :   Integer;              // Œ_
  SideN   :   Integer;              // EӐ
//  XMAX    :   Double;               // XWől
//  YMAX    :   Double;               // YWől
  XN, YN  :   integer;              // X,Y 
  hitF    :   boolean;              // ObhɃqbgtO
  IMouseF :   boolean;              // ImageɃ}EXtO
  GridMakeF : boolean;              // Obh}tO
  Carea   :   Integer;              // }EXʒu`FbNGA
  SUX     :   Double;               // XP[
  Origin    : Tpoint;                       // n_
  MovePt    : Tpoint;                       // ړ̊Jnʒu
  MousPd  :   boolean;                      // }EX_EtO
  FldfilF :   boolean;                      // hԂtO
  LinesF  :   boolean;                      // tO
  BackTo: array[0..BackMax - 1, 0..5] of integer;     // Xpos, Ypos Line paint
  BackNo    : Integer;                        // obNAbvzԍ
  EleChF    : Boolean;
  Keisu: double;

procedure TForm1.ClchangeBtnClick(Sender: TObject);
begin
  if Image1.Canvas.Pen.Color = clBlue then begin
    Image1.Canvas.Pen.Color := clRed;
    LineColorEdit.Color := clRed;
  end
  else begin
    Image1.Canvas.Pen.Color := clBlue;
    LineColorEdit.Color := clBlue;
  end;
end;

procedure TForm1.EleChBtnClick(Sender: TObject);
begin
  EleChBtn.Enabled := False;
  ElementCheck;                       // vf̓`FbN
  GridMakeF := True;                  // Obh}tOZbg
  LinesF := True;                     // `FbNtOZbg
  FldfilF := False;                   // hԂtOZbg
  PaintBtn.Enabled := False;
  LineBackBtn.Enabled := False;
  EleChF := True;                     // vf`FbNtOZbg
  BackNo := 0;                        // ߂NA
  Image1.Canvas.Pen.Color := clBlue;  // wpɐ̐FɃZbg
  LineColorEdit.Color := clBlue;      // ̐F\
  Image1.Canvas.Pen.Width := 3;       // ̕
  ClchangeBtn.Enabled := True;        // ̐FύXpɐFύX{^Cl[u
  InoutChkBtn.Enabled := True;        // omF{^Cl[u
  MLabel.Caption := 'ŁAoԐō}܂B' + #13#10 +
                    'w肪IAomFłB';
end;

procedure TForm1.ElementCheck;        // vf̓`FbN
var
  XX, YY    :   Integer;
  XYN       :   Integer;
  ElNo      :   Integer;                  // vfJE^[
  XI, YI    :   Integer;                  //
  ChPos     :   array[0..3, 0..1] of integer;   // `FbNʒuvZplӏXY
  CXP, CYP  :   integer;                        // `FbNSʒuwx
  Checkeds  :   array[0..3] of boolean;         // `FbNʎlӏ
  NEIPXY    :   array of array of array of integer;    // vf_W
  Elppos    :   array of array of integer;             // ߓ_wxW  ߓ_̍Wwx̂
begin
// vf̊mFhԂ̈̌               // vf̐`FbNp
  ElNo := 0;                                            // vfJE^[NA
  for YY := 1 to YN do begin                            // xW͋tɂȂ̂Œ 傫ق珬ق
    for XX := 0 to XN - 1 do  begin                     // wW͏ق傫ق
      CXP := XYPos[XX, YY, 0];                          // Obhlp`Sɑ΂ď㉺Ëʒu̍W쐬
      CYP := XYPos[XX, YY, 1];                          // Carea SC / 2
      ChPos[0, 0] := CXP + Carea - Round(SX / 4);       // hԂʒumFwW
      ChPos[0, 1] := CYP + Carea;                       // hԂʒumFxW
      ChPos[1, 0] := CXP + Carea;                       // hԂʒumFwW
      ChPos[1, 1] := CYP + Carea + Round(SX / 4);       // hԂʒumFxW
      ChPos[2, 0] := CXP + Carea + Round(SX / 4);       // hԂʒumFwWE
      ChPos[2, 1] := CYP + Carea;                       // hԂʒumFxW
      ChPos[3, 0] := CXP + Carea;                       // hԂʒumFwW
      ChPos[3, 1] := CYP + Carea - Round(SX / 4);       // hԂʒumFxW
      for XYN := 0 to 3 do begin                        // Obhlp̒S㉺E̎lӏhԂĂ邩mF
        if (Image1.Canvas.Pixels[ChPos[XYN, 0], ChPos[XYN, 1]] = PaintColor)  then Checkeds[XYN] := True    // hԂĂTrue
                                                                              else Checkeds[XYN] := False;  // hԂĂȂFalse
      end;
      if Checkeds[0] and Checkeds[1] and Checkeds[2] and Checkeds[3] then Inc(ElNo, 2)  // lӏhԂĂ vfǉ
        else                                                                            // Ⴄꍇ
        begin                                                                           // l̑gݍ킹mF
          if Checkeds[0] and Checkeds[1] then Inc(ElNo);                                // gݍ킹vfǉ
          if Checkeds[1] and Checkeds[2] then Inc(ElNo);                                // gݍ킹vfǉ
          if Checkeds[2] and Checkeds[3] then Inc(ElNo);                                // gݍ킹vfǉ
          if Checkeds[3] and Checkeds[0] then Inc(ElNo);                                // gݍ킹vfǉ
        end;
    end;
  end;
  CheckLabel.Caption := intTostr(ElNo);
// vfɑ΂Aߓ_pW̔z쐬
  SetLength(NEIPXY, ElNo, 3, 2);
// evf̐ߓ_ɑ΂W̌
  ElNo := 0;                                            // vfJE^[NA
  for YY := 1 to YN do begin                            // xW͋tɂȂ̂Œ 傫ق珬ق
    for XX := 0 to XN - 1 do  begin                     // wW͏ق傫ق
      CXP := XYPos[XX, YY, 0];                          // Obhlp`Sɑ΂ď㉺Ëʒu̍W쐬
      CYP := XYPos[XX, YY, 1];
      ChPos[0, 0] := CXP + Carea - Round(SX / 4);       // Carea SC / 2 hԂʒumFwW
      ChPos[0, 1] := CYP + Carea;                       // hԂʒumFxW
      ChPos[1, 0] := CXP + Carea;                       // hԂʒumFwW
      ChPos[1, 1] := CYP + Carea + Round(SX / 4);       // hԂʒumFxW
      ChPos[2, 0] := CXP + Carea + Round(SX / 4);       // hԂʒumFwWE
      ChPos[2, 1] := CYP + Carea;                       // hԂʒumFxW
      ChPos[3, 0] := CXP + Carea;                       // hԂʒumFwW
      ChPos[3, 1] := CYP + Carea - Round(SX / 4);       // hԂʒumFxW
      for XYN := 0 to 3 do begin                        // Obhlp̒S㉺E̎lӏhԂĂ邩mF
        if (Image1.Canvas.Pixels[ChPos[XYN, 0], ChPos[XYN, 1]] = PaintColor)  then Checkeds[XYN] := True
                                                                              else Checkeds[XYN] := False;
      end;
      if Checkeds[0] and Checkeds[1] and Checkeds[2] and Checkeds[3] then begin   // lSēhĂ vf
        NEIPXY[ElNo, 0, 0] := XYPos[XX, YY - 1, 0];          // ڍWݒ v
        NEIPXY[ElNo, 0, 1] := XYPos[XX, YY - 1, 1];          //  2
        NEIPXY[ElNo, 1, 0] := XYPos[XX + 1, YY - 1, 0];      //  aa
        NEIPXY[ElNo, 1, 1] := XYPos[XX + 1, YY - 1, 1];      //  0a1
        NEIPXY[ElNo, 2, 0] := XYPos[XX, YY, 0];
        NEIPXY[ElNo, 2, 1] := XYPos[XX, YY, 1];
        Inc(ElNo);                                           // vfJE^[CNg
        NEIPXY[ElNo, 0, 0] := XYPos[XX + 1, YY - 1, 0];      // ڍWݒ v
        NEIPXY[ElNo, 0, 1] := XYPos[XX + 1, YY - 1, 1];      //  2a1
        NEIPXY[ElNo, 1, 0] := XYPos[XX + 1, YY, 0];          //   aa
        NEIPXY[ElNo, 1, 1] := XYPos[XX + 1, YY, 1];          //    0
        NEIPXY[ElNo, 2, 0] := XYPos[XX, YY, 0];
        NEIPXY[ElNo, 2, 1] := XYPos[XX, YY, 1];
        Inc(ElNo);                                           // vfJE^[CNg
      end
      else
      begin                                                  // hԂ̈ʒuŎl^CvI
        if Checkeds[0] and Checkeds[1] then begin            // 0-1 ^Cv
          NEIPXY[ElNo, 0, 0] := XYPos[XX, YY - 1, 0];        // Wݒ v
          NEIPXY[ElNo, 0, 1] := XYPos[XX, YY - 1 , 1];       //  2
          NEIPXY[ElNo, 1, 0] := XYPos[XX + 1, YY - 1, 0];    //  aa
          NEIPXY[ElNo, 1, 1] := XYPos[XX + 1, YY - 1, 1];    //  0a1
          NEIPXY[ElNo, 2, 0] := XYPos[XX, YY, 0];
          NEIPXY[ElNo, 2, 1] := XYPos[XX, YY, 1];
          Inc(ElNo);                                         // vfJE^[CNg
        end;
        if Checkeds[1] and Checkeds[2] then begin            // 1-2 ^Cv
          NEIPXY[ElNo, 0, 0] := XYPos[XX, YY - 1, 0];        // Wݒ v
          NEIPXY[ElNo, 0, 1] := XYPos[XX, YY - 1, 1];        //   2
          NEIPXY[ElNo, 1, 0] := XYPos[XX + 1, YY - 1, 0];    //  aa
          NEIPXY[ElNo, 1, 1] := XYPos[XX + 1, YY - 1, 1];    // 0a1
          NEIPXY[ElNo, 2, 0] := XYPos[XX + 1, YY, 0];
          NEIPXY[ElNo, 2, 1] := XYPos[XX + 1, YY, 1];
          Inc(ElNo);                                         // vfJE^[CNg
        end;
        if Checkeds[2] and Checkeds[3] then begin            // 2-3 ^Cv
          NEIPXY[ElNo, 0, 0] := XYPos[XX, YY, 0];            // Wݒ v
          NEIPXY[ElNo, 0, 1] := XYPos[XX, YY, 1];            //  0a2
          NEIPXY[ElNo, 1, 0] := XYPos[XX + 1, YY - 1, 0];    //   aa
          NEIPXY[ElNo, 1, 1] := XYPos[XX + 1, YY - 1, 1];    //    1
          NEIPXY[ElNo, 2, 0] := XYPos[XX + 1, YY, 0];
          NEIPXY[ElNo, 2, 1] := XYPos[XX + 1, YY, 1];
          Inc(ElNo);                                         // vfJE^[CNg
        end;
        if Checkeds[3] and Checkeds[0] then begin            // 3-0 ^Cv
          NEIPXY[ElNo, 0, 0] := XYPos[XX, YY - 1, 0];        // Wݒ v
          NEIPXY[ElNo, 0, 1] := XYPos[XX, YY - 1, 1];        //  2a1
          NEIPXY[ElNo, 1, 0] := XYPos[XX + 1, YY, 0];        //  aa
          NEIPXY[ElNo, 1, 1] := XYPos[XX + 1, YY, 1];        //  0
          NEIPXY[ElNo, 2, 0] := XYPos[XX, YY, 0];
          NEIPXY[ElNo, 2, 1] := XYPos[XX, YY, 1];
          Inc(ElNo);                                         // vfJE^[CNg
        end;
      end;
    end;
  end;
  GraphClear;          // OtNA
  Image1.Canvas.Pen.Color := clGreen;                        //
  Image1.Canvas.Pen.Width := 1;
  for YY := 0 to ElNo - 1 do begin                           // vf}
    Image1.Canvas.MoveTo(NEIPXY[YY, 2, 0], NEIPXY[YY, 2, 1]);
    for XX := 0 to 2 do
          Image1.Canvas.LineTo(NEIPXY[YY, XX, 0], NEIPXY[YY, XX, 1]);
  end;
// ߓ_W Obh _ ԍ 

  SetLength(Elppos, ElNo * 3, 2);
// ߓ_̍Wo vf̎Oߓ_W w  x ̍WƂĈɕׂ
  for YY := 0 to ElNo - 1 do begin
    for XX := 0 to 2 do begin
      Elppos[YY * 3 + XX, 0] := NEIPXY[YY, XX, 0];
      Elppos[YY * 3 + XX, 1] := NEIPXY[YY, XX, 1];
    end;
  end;
// ߓ_̍W\[g ou\[g    wxŴ̂΂
  for YY := ElNo * 3 downto 0 do        // wWɃ\[g
    for XX := 0 to YY - 2 do begin
      if Elppos[XX, 0] < Elppos[XX + 1, 0] then begin
        XI := Elppos[XX, 0];
        Elppos[XX, 0] := Elppos[XX + 1, 0];
        Elppos[XX + 1, 0] := XI;
        YI := Elppos[XX, 1];
        Elppos[XX, 1] := Elppos[XX + 1, 1];
        Elppos[XX + 1, 1] := YI;
      end;
    end;
  for YY := ElNo * 3 downto 0 do        // xWɃ\[g
    for XX := 0 to YY - 2 do begin
      if Elppos[XX, 1] < Elppos[XX + 1, 1] then begin
        YI := Elppos[XX, 1];
        Elppos[XX, 1] := Elppos[XX + 1, 1];
        Elppos[XX + 1, 1] := YI;
        XI := Elppos[XX, 0];
        Elppos[XX, 0] := Elppos[XX + 1, 0];
        Elppos[XX + 1, 0] := XI;
      end;
    end;
// ߓ_̍WwWxWgݍ킹̂̈c ߓ_m肷
  XYN := 0;
  for YY :=  0 to ElNo * 3 do begin
    for XX := 0 to ElNo * 3 - 2 do begin
      if (Elppos[XX, 0] = Elppos[XX + 1, 0]) and (Elppos[XX, 1] = Elppos[XX + 1, 1]) then begin  // XYߓ_ŴƓ
        for XI := XX + 1 to ElNo * 3 - 2 do begin     // ߂
          Elppos[XI, 0] := Elppos[XI + 1, 0];
          Elppos[XI, 1] := Elppos[XI + 1, 1];
        end;
        Dec(XYN);
        Elppos[ElNo * 3 - 1, 0] := XYN;               // wԍŌ}CiXߓ_ԍɂ
        Elppos[ElNo * 3 - 1, 1] := XYN;               // xԍŌ}CiXߓ_ԍɂ
      end;
    end;
  end;
// ߓ_̐JEg
  NP := 0;
  for YY := 0 to ElNo * 3  - 1 do begin
    if Elppos[YY, 0] > -1 then inc(NP)                // ߓ_WɃ[ȉ͖ - ɂȂʒȗO܂ŃJEg
                          else break;
  end;
  NE := ElNo;
  CheckLabel.Caption := intTostr(NP);
  SetArrayLengthA;         // zm A
// vfߓ_ԍݒ
  for XX := 0 to ElNo - 1 do begin                    // SĂ̗vf
    for YY := 0 to 2 do begin                         // vf̐ߓ_Oӏ
      XI := NEIPXY[XX , YY, 0];                       // vfߓ_wW
      YI := NEIPXY[XX , YY, 1];                       // vfߓ_xW
      for XYN := 0 to NP -1 do begin                                  // SĂ̐ړ_
        if (XI = Elppos[XYN, 0]) and (YI = Elppos[XYN, 1]) then begin // wxWv
          IP[XX, YY] := XYN + 1;                                      // vf̐ߓ_ԍZbg
          Break;                                                      // ̍W
        end;
      end;
    end;
  end;
// W̏CZbg OtBbNW _X0,Y0 vf̍Wɕϊ
  for XX := 0 to NP -1 do begin
    X[XX] := Elppos[XX, 0] - X0;            // ߓ_wW
    Y[XX] := Y0 - Elppos[XX, 1];            // ߓ_xW
  end;
  S := 1;                                   // ʂɃXP[Ă̂ 1
  XYPosMake;                                // }pW쐬@}
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Color := clGreen;
  EleOut;                                   // vf} owp
//  MainCalc;                  // MainvZ
end;

procedure TForm1.GraphClear;          // OtNA
var
  Rect: Trect;
begin
  Rect.Top := 0;
  Rect.Left := 0;
  Rect.Right := Image1.Width;
  Rect.Bottom := Image1.Height;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.FillRect(Rect);
  GridMakeF := False;
end;

procedure TForm1.GridMake;          // Obh}
var
  II, KK : integer;
  XP, YP : integer;
begin
  setlength(XYPos, XN + 1, YN + 1, 2);                      // XYWzm
  SX := 660 / XN;                                           // Xsb`
  SY := 440 / YN;                                           // Ysb`
  if SX > SY then SX := SY;                                 // ̃sb`ɍ킹
  Carea := round(SX / 2 + 0.5);
  Image1.Canvas.Pen.Style := PsSolid;                       // A
  Image1.Canvas.Pen.Width := 1;                             // 
  Image1.Canvas.Pen.Color := clskyblue;                     // FXJCu[
  for II := 0 to XN do                                                // ObhWzf[^[쐬
    for KK := 0 To YN do begin
      XP := X0 + Round(II * SX);
      YP := Y0 - Round(KK * SX);
      XYPos[II, KK, 0] := XP;
      XYPos[II, KK, 1] := YP;
    end;
  for II := 0 to XN do begin                                          // }
    Image1.Canvas.MoveTo(XYPos[II, 0, 0], XYPos[0, 0, 1]);
    Image1.Canvas.LineTo(XYPos[II, 0, 0], XYPos[0,YN, 1]);
  end;
  for II := 0 to YN do begin                                          // }
    Image1.Canvas.MoveTo(XYPos[ 0, 0, 0], XYPos[0,II, 1]);
    Image1.Canvas.LineTo(XYPos[XN, 0, 0], XYPos[0,II, 1]);
  end;
  GridMakeF := True;                                                  // Obh}tOZbg
  Image1.Canvas.Pen.Color := clRed;                                   // wp̃yZbg
  LineColorEdit.Color := clRed;                                       // y̐F\
  Image1.Canvas.Pen.Width := 2;
end;

procedure TForm1.PaintBtnClick(Sender: TObject);
begin
  if MousPd then exit;
  FldfilF := True;
  EleChBtn.Enabled := True;
  MLabel.Caption := 'vf̊mFsĂB' + #13#10 +
                    '() vf̊mFƁA֖߂܂B';
end;

procedure TForm1.PosCheck(var X, Y: integer);
var
  II, KK : integer;
  XP, YP : integer;
begin
  hitF := False;                          // qbgtO
  if GridMakeF then begin                 // Obh}Ă
    if IMouseF then begin                 // Image1Ƀ}EX
      for II := 0 to XN do begin          // ߂Obh_ɍWwZbg
        XP := XYPos[II, 0, 0];
        if (X < XP + Carea) and (X > XP - Carea) then begin    // wqbg
          for KK := 0 to YN do begin        // }EXɋ߂Obhx
            YP := XYPos[0, KK, 1];          // ߂Obh_ɍWxZbg
            if (Y < YP + Carea) and (Y > YP - Carea) then begin  // xqbg
              Checklabel.Caption := 'hit';                       // hit \
              X := XP;                      // z̃f[^[wɕύX
              Y := YP;                      // z̃f[^[xɕύX
              hitF := True;                 // ObhɃqbgtOZbg
              break;                        // ܂
            end;
          end;
        end;
        if hitF then break;               // qbg獟܂
      end;
      if not hitf then Checklabel.Caption := 'not hit';   // qbgȂꍇ
    end;
  end else hitF := True;                  // Obh}ĂȂꍇ͏Ƀqbg
end;

procedure TForm1.RedrowBtnClick(Sender: TObject);
begin
  GraphClear;          // OtNA
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Color := clGray;
  EleOut;                                   // vf}
  FlowOut;                                  // }
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if not GridMakeF then exit;
  if BackMax <= BackNo then exit;
  if FldfilF then begin                     // hԂtO
    Image1.Canvas.Brush.Style := bsSolid;           // hԂX^C
    Image1.Canvas.Brush.Color := PaintColor;        // hԂF
    Image1.Canvas.FloodFill(X, Y, clRed, fsBorder); // hԂ
    Image1.Canvas.Brush.Color := clwhite;           // hԂF߂
    Backto[BackNo, 0] := X;                         // hԂW@w
    Backto[BackNo, 1] := Y;                         // hԂW@x
    Backto[BackNo, 2] := clRed;                     // EF
    Backto[BackNo, 3] := integer(fsBorder);         // hԂ
    Backto[BackNo, 4] := 1;                         // PhԂ
    Backto[BackNo, 5] := Image1.Canvas.Brush.Color; // PhԂF
    inc(BackNo);                                    // obNAbvԍCNg
    LineBackBtn.Enabled := True;                    // obN{^Cl[u
    exit;
  end;
  if LineSF then begin
    PosCheck(X, Y);                           // ߂Obḧʒu
    if hitF then begin                        // ObhɃqbgĂ
      if not MousPd then begin
        Origin  := point(X, Y);               // n_
        MovePt  := point(X, Y);               // ړ̊Jnʒu
        MousPd  := True;                      // }EX_EtO
      end
      else begin
        if (Origin.X = X) and (Origin.Y = Y) then begin
          MousPd := False;
          exit;
        end;
        Image1.Canvas.Moveto(Origin.X, Origin.Y);   // ēxn_Zbg
        Image1.Canvas.Lineto(X, Y);                 // V_ɐ
        Backto[BackNo, 0] := Origin.X;              // n_wWobNAbv
        Backto[BackNo, 1] := Origin.Y;              // n_xWobNAbv
        Backto[BackNo, 2] := X;                     // I_wWobNAbv
        Backto[BackNo, 3] := Y;                     // I_xWobNAbv
        Backto[BackNo, 4] := 0;                     // O͐
        Backto[BackNo, 5] := Image1.Canvas.Pen.Color; //
        inc(BackNo);                                // obNAbvԍCNg
        LineBackBtn.Enabled := True;                // obN{^Cl[u
        if not EleChF then PaintBtn.Enabled := True;                   // hԂ{^Cl[u
        MousPd := False;
      end;
    end;
  end;
end;

procedure TForm1.Image1MouseEnter(Sender: TObject);
begin
  IMouseF := True;                          // }EXImage1ɗ̈ɓtOZbg
end;

procedure TForm1.Image1MouseLeave(Sender: TObject);
begin
  IMouseF := False;                         // }EXImage1ɗ̈ɓtOZbg
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
begin
  if not GridMakeF then exit;
  if BackMax <= BackNo then exit;
  if LinesF then begin
    PosCheck(X, Y);                           // ߂Obḧʒu
    if MousPd then begin
      Image1.Canvas.Pen.Mode := pmNotXor;         // y[hZbg
      Image1.Canvas.Moveto(Origin.X, Origin.Y);   // n_Zbg
      Image1.Canvas.Lineto(MovePt.X, MovePt.Y);   // O̐
      Image1.Canvas.Moveto(Origin.X, Origin.Y);   // ēxn_Zbg
      Image1.Canvas.Lineto(X, Y);                 // V_ɐ
    end;
    MovePt := point(X, Y);                 // I_Zbg
    Image1.Canvas.Pen.Mode := pmCopy;      // y[hZbg
  end;
end;

procedure TForm1.InoutChkBtnClick(Sender: TObject);
label
  Keisuj;
var
  II, KK: Integer;
  XP1, XP2, YP1, YP2 : Double;
  XC, YC : Integer;
  RC, BC : Integer;
  CColor : TColor;
  BLBP   : array of array of integer;
  RDBP   : array of array of integer;
  IP0, IP1  : integer;
  KKP    : integer;
begin
  if Savebtn.Enabled then goto Keisuj;
  InoutChkBtn.Enabled := False;
  Setlength(BLBP, NE, 2);                     // mFz vfp
  Setlength(RDBP, NE, 2);                     // ԐmFz vfp
  BC := 0;
  RC := 0;
  for II := 0 to NE - 1 do begin              // Svf
    for kk := 0 to 2 do begin                 // RӃ`FbN
      XP1 := FNX[II, KK];                     // n_̐ߓ_W
      YP1 := FNY[II, KK];
      IP0 := IP[II,  KK];                     // ߓ_ԍ
      KKP := (KK + 1) mod 3;                  // 1,2,3 -> 1,2,0
      XP2 := FNX[II, KKP];                    // I_̐ߓ_W
      YP2 := FNY[II, KKP];
      IP1 := IP[II,  KKP];                    // ߓ_ԍ
      XC := Round((XP1 + XP2) / 2);           // ԓ_̂wW
      YC := Round((YP1 + YP2) / 2);           // ԓ_̂xW
      CColor := image1.Canvas.Pixels[XC, YC]; // F̎o
      if CColor = clBlue then begin           // F
        BLBP[BC, 0] := IP0;                   // Jnߓ_zԍZbg
        BLBP[BC, 1] := IP1;                   // I_ߓ_zԍZbg
        Inc(BC);                              // wJEg
      end;
      if CColor = clRed  then begin           // ԐF
        RDBP[RC, 0] := IP0;                   // Jnߓ_zԍZbg
        RDBP[RC, 1] := IP1;                   // I_ߓ_zԍZbg
        Inc(RC);                              // ԎwJEg
      end;
      CheckLabel.Caption := intTostr(BC + RC);
    end;
  end;
  if RC = 0 then begin
    Application.MessageBox('Ԑ@o̎w肪܂','',0);
  end;
  if BC = 0 then begin
    Application.MessageBox('@̎w肪܂','',0);
  end;
  if (RC = 0) or (BC = 0) then begin
    InoutChkBtn.Enabled := true;
    exit;
  end;
  FixN := 0;                          // Œ_͂ȂĂ
  SideN := BC + RC;
  SetArrayLengthB;                    // zm B
  for II := 0 to BC -1 do begin
    IOV[II, 0] := BLBP[II, 0];        // ߓ_ԍ
    IOV[II, 1] := BLBP[II, 1];        // ߓ_ԍ
    IOF[II] := -1;                    // ʂ̃Zbg
  end;
  for II := 0 to RC -1 do begin
    IOV[II + BC, 0] := RDBP[II, 0];   // ߓ_ԍ
    IOV[II + BC, 1] := RDBP[II, 1];   // ߓ_ԍ
    IOF[II + BC] := BC / RC;          // oʂ̃Zbg ʂƓʂɐ悤ɂ
  end;
  inc(BackNO);
Keisuj:
  GraphClear;          // OtNA
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Color := clGray;
  EleOut;                                   // vf}
  FemCalc;                                  // FemvZ
  SUX := SX / 2;                            // \W
  FlowOut;                                  // }
  InoutChkBtn.Enabled := True;
  Savebtn.Enabled := True;
  RedrowBtn.Enabled := True;                // ĕ\{^Cl[u
  MLabel.Caption := 'o̎w܂ł͖߂Ƃo܂' + #13#10 +
                    't@Cɕۑł܂';
end;
//  SetLength(IOV, SideN, 2);                 // EӐ Ӑߓ_ԍ
//  SetLength(IOF, SideN);                    // ʏ


procedure TForm1.LineBackBtnClick(Sender: TObject); // ߂{^NbN
var
  II : integer;
  ColorBack: Tcolor;
begin
  if MousPd then exit;
  if BackNo > 0 then dec(BackNo);                // ߂JE^[[傫fNg
  if BackNo = 0 then LineBackBtn.Enabled := False;     // ߂JE^[[߂{^fXGu
  if EleChF then begin                        // vfmFς݂
    ColorBack := Image1.Canvas.Pen.Color;
    GraphClear;                               // OtNA
    GridMakeF := True;                        // OtNAŃZbg邽ߍăZbg
    Image1.Canvas.Pen.Width := 1;
    Image1.Canvas.Pen.Color := clGreen;
    EleOut;                                   // vf}
    Image1.Canvas.Pen.Width := 3;
    for II := 0 to BackNo - 1 do begin                          // }Đ
      Image1.Canvas.Pen.Color := BackTo[II, 5];
      Image1.Canvas.Moveto(BackTo[II, 0], BackTo[II, 1]);       // ̎n_
      Image1.Canvas.Lineto(BackTo[II, 2], BackTo[II, 3]);       // ̏I_
    end;
    Image1.Canvas.Pen.Color := ColorBack;
    LineColorEdit.Color := ColorBack;
    Savebtn.Enabled := False;
    RedrowBtn.Enabled := False;               // ĕ\{^fBXGu
    MLabel.Caption := 'ŁAoԐō}܂B' + #13#10 +
                      'w肪IAomFłB';
    exit;
  end;
  GraphClear;           // OtNA
  GridMake;             // Obh}
  LinesF := False;                                              // tOZbg
  FldfilF := False;                                             // hԂtOZbg
  EleChBtn.Enabled := False;                                    // vf`FbN{^fBXGu
  for II := 0 to BackNo - 1 do begin                            // }Đ
    if BackTo[II, 4] = 0 then begin                             // 
      Image1.Canvas.Pen.Color := BackTo[II, 5];                 // ̐F
      Image1.Canvas.Moveto(BackTo[II, 0], BackTo[II, 1]);       // ̎n_
      Image1.Canvas.Lineto(BackTo[II, 2], BackTo[II, 3]);       // ̏I_
    end
    else begin
      Image1.Canvas.Brush.Style := bsSolid;                     // hԂp^[
      Image1.Canvas.Brush.Color := BackTo[II, 5];               // uV̐F
      Image1.Canvas.FloodFill(BackTo[II, 0], BackTo[II, 1], BackTo[II, 2], TFillStyle(BackTo[II, 3]));  // hԂ
      Image1.Canvas.Brush.Color := clwhite;                     // uV̐F߂
      EleChBtn.Enabled := True;                                 // vf`FbN{^Cl[u
    end;
  end;
  RedrowBtn.Enabled := False;                                   // ĕ\{^fBXGu
  Savebtn.Enabled := False;
end;

procedure TForm1.LineBtnClick(Sender: TObject);
begin
  FldfilF := False;                       // hԂtOZbg
  LinesF  := True;                        // tOZbg
end;

procedure TForm1.GridBtnClick(Sender: TObject);
var
  Check: integer;
begin
  if MousPd then exit;
  Val(XNEdit.Text, XN, Check);          // w
  if Check <> 0 then application.MessageBox('w̕Ɍ肪܂B','̓~X',0);
  if XN < 3 then application.MessageBox('w̕Ȃ܂B','̓~X',0);
  Val(YNEdit.Text, YN, Check);          // x
  if Check <> 0 then application.MessageBox('x̕Ɍ肪܂B','̓~X',0);
  if YN < 3 then application.MessageBox('x̕Ȃ܂B','̓~X',0);
  GraphClear;                                 // OtNA
  GridMake;                                   // Obh}
  BackNo := 0;                                // ߂JE^[Zbg
  LineBackBtn.Enabled := False;
  PaintBtn.Enabled := False;
  EleChBtn.Enabled := False;
  ClchangeBtn.Enabled := False;
  InoutChkBtn.Enabled := False;
  FldfilF := False;                       // hԂtOZbg
  LinesF  := True;                        // tOZbg
  EleChF := False;                        // hԂtOZbg
  RedrowBtn.Enabled := False;             // ĕ\{^fBXGu
  Savebtn.Enabled := False;
  MLabel.Caption := '͂ޗlɍ}܂A΂ߕ͂STȊOgpȂŉ' + #13#10 +
                    '\łB' + #13#10 +
                    '}IAhԂ܂B';
end;

procedure TForm1.FlowOut;        // }
var
  I, J                  : Integer;
  X1, X2, Y1, Y2, V, U  : Double;
  X11, X22, Y11, Y22    : Integer;
begin
  val(Keisuedit. Text, Keisu, I);                           // \W
  if I <> 0 then Keisu := 1;                                // lłȂ\TCYW=1
  for J := 0 to NE -1 do                                    // SĂ̗vf
    begin
      U := 0;
      V := 0;
      X1 := 0;
      Y1 := 0;
      for I := 0 to 2 do                                    // vfߓ_Oӏ
        begin
          X11 := IP[J, I] - 1;                              // ߓ_ԍ͂P}CiX zԍɂ
          U := U + B[J, I] * P[X11] / SA[J];                // ߓ_OӏZ ʐόWŊ葬xɂ B[] Y̋
          V := V + A[J, I] * P[X11] / SA[J];                // ߓ_OӏZ ʐόWŊ葬xɂ A[] X̋
          X1 := X1 + X[X11];                                // Oӏ̂wWZ
          Y1 := Y1 + Y[X11];                                // Oӏ̂xWZ
        end;
      X1 := X0 + X1 * S / 3;                                // vfSwW
      Y1 := Y0 - Y1 * S / 3;                                // vfSxW
      X2 := X1 + U * SUX * Keisu;                           //  U  X
      Y2 := Y1 - V * SUX * Keisu;                           //  V  Y
      X11 := Round(X1);
      X22 := Round(X2);
      Y11 := Round(Y1);
      Y22 := Round(Y2);
      Image1.Canvas.Pen.Color := clRed;                           // n_~̐F
      Image1.Canvas.Ellipse(X11 - 1, Y11 - 1, X11 + 2, Y11 + 2);  // n_~}
      Image1.Canvas.Pen.Color := clBlue;                          // ̐F
      Image1.Canvas.MoveTo(X11, Y11);                             // n_
      Image1.Canvas.LineTo(X22, Y22);                             // I_
    end;
end;

procedure TForm1.EleOut;         // vf}
var
  J, I  : Integer;
begin
  for J := 0 to NE - 1 do                 // SĂ̗vf
    begin
      Image1.Canvas.MoveTo(Round(FNX[J, 2]), Round(FNY[J, 2]));                     // ŏ̓_
      for I := 0 to 2 do Image1.Canvas.LineTo(Round(FNX[J, I]), Round(FNY[J, I]));  // vf
    end;
end;

procedure TForm1.SetArrayLengthA;         // zm A
begin
  SetLength(X, NP);                         // XW
  SetLength(Y, NP);                         // YW
  SetLength(P, NP);                         // ߓ_|eV
  SetLength(SA, NE);                        // vfW
  SetLength(K, NP, NP);                     // }gbNX
  SetLength(IP, NE, 3);                     // vfߓ_ԍ
  SetLength(A, NE, 3);                      // X
  SetLength(B, NE, 3);                      // Y
  SetLength(FNX, NE, 3);                    // }pW
  SetLength(FNY, NE, 3);
end;

procedure TForm1.SetArrayLengthB;           // zm B
begin
  SetLength(IB, FixN);                      // Œ_
  SetLength(PB, FixN);                      // EӐ
  SetLength(IOV, SideN, 2);                 // EӐ Ӑߓ_ԍ
  SetLength(IOF, SideN);                    // ʏ
end;

procedure TForm1.XYPosMake;                 // }pW쐬@}
var
  J, I: Integer;
begin
// }pW쐬
  for J := 0 to NE - 1 do
    begin
      for I := 0 to 2 do
        begin
          FNX[J, I] := X0 + X[IP[J, I] - 1] * S; // }W   ߓ_ԍ͂P}CiX zԍɂ
          FNY[J, I] := Y0 - Y[IP[J, I] - 1] * S; // ߓ_ԍ͂P}CiX zԍɂ
        end;
    end;
end;

procedure TForm1.FemCalc;                  // FemvZ
var
  I1, I2        : Integer;
  I, J, II, JJ  : Integer;
  IA, JA        : Integer;
  VN, QQ, KM, KK: Double;
begin
  for I := 0 to NP -1 do                   // zNA
    begin
      P[I] := 0;
      for J := 0 to Np - 1 do K[I, J] := 0;
    end;
// }gbNX̍쐬
  for J := 0 to NE - 1 do
    begin
      for I := 0 to 2 do
        begin
          I1 := (I + 1) mod 3;                             // 1, 2, 0
          I2 := (I + 2) mod 3;                             // 2, 0, 1
          A[J, I] := X[IP[J, I2] - 1] - X[IP[J, I1] - 1];  // ߓ_ԍ͂P}CiX zԍɂ @wW̍
          B[J, I] := Y[IP[J, I1] - 1] - Y[IP[J, I2] - 1];  // ߓ_ԍ͂P}CiX zԍɂ   xW̍
        end;
      SA[J] := B[J, 0] * A[J, 1] - B[J, 1] * A[J, 0];      // Q~ʐόvZ (ʐς̓{)
      for II := 0 to 2 do
        for JJ := 0 to 2 do
          begin
            IA := IP[J, II] - 1;                           // ߓ_ԍ͂P}CiX zԍɂ
            JA := IP[J, JJ] - 1;                           // ߓ_ԍ͂P}CiX zԍɂ
            K[IA, JA] := K[IA, JA] + (A[J, II] * A[J, JJ] + B[J, II] * B[J, JJ]) / SA[J] / 2;   // }gbNXɉZ
          end;
    end;
// Œ_̏ Œ_0 ł
  if FixN > 0 then
    begin
      for I := 0 to FixN - 1 do                            // Œ_
        begin
          I1 := IB[I] - 1;                                 // ߓ_ԍ͂P}CiX zԍɂ
          for J := 0 to NP - 1 do P[J] := P[J] - K[J, I1] * PB[I];  // Œ_ x|eV
          for J := 0 to NP - 1 do                                   // Œ_̗ƍs[ɂ
            begin
              K[J, I1] := 0;
              K[I1, J] := 0;
            end;
          K[I1, I1] := 1;                                           // Ίp̒l1Zbg
          P[I1] := PB[I];                                           // Œ_x|eVZbg
        end;
    end;
// Eӂ̏   Ɨo  }CiX o vX
  if SideN > 0 then
    begin
      for I := 0 to SideN - 1do                 // o
        begin
          I1 := IOV[I, 0] - 1;                  // ߓ_ԍ͂P}CiX zԍɂ
          I2 := IOV[I, 1] - 1;                  // ߓ_ԍ͂P}CiX zԍɂ
          VN := IOF[I];                         // @x
          QQ := VN * SQRT(SQR(X[I1] - X[I2]) + SQR(Y[I1] - Y[I2])) / 2;  // ߓ_|eVvZ
          P[I1] := P[I1] + QQ;              // 0ߓ_ɉZ
          P[I2] := P[I2] + QQ;              // 1ߓ_ɉZ
        end;
    end;
// }gbNX̉
  for I := 0 to NP - 1do
    begin
      KM := K[I, I];                        // Ίp̒l
      if KM <> 0 then begin                 // [łȂs [ŏẐh~ [ɂȂ͍̂}gbNX̍쐬~X
        P[I] := P[I] / KM;
        for J := 0 to NP - 1 do K[I, J] := K[I, J] / KM;
      end;
      for J := 0 to NP - 1 do
        begin
          if J <> I then                    // Ίp͌vZȂ
            begin
              KK := K[J, I];
              If KK <> 0 then               // [̏ꍇvZĂςȂ̂Ń[ȊÔ݌vZ
                begin
                  P[J] := P[J] - KK * P[I];
                  for JJ := 0 to NP -1 do K[J, JJ] := K[J, JJ] - KK * K[I, JJ];
                end;
            end;
        end;
    end;
end;

procedure TForm1.MainCalc;                  // MainvZ
begin
  GraphClear;                               // OtNA
  XYPosMake;                                // }pW쐬@}
  Image1.Canvas.Pen.Width := 1;
  Image1.Canvas.Pen.Color := ClGray;
  EleOut;                                   // vf}
  FemCalc;                                  // FemvZ
  FlowOut;                                  // }
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Bitmapd: Tbitmap;
begin
  ClientWidth := 800;
  ClientHeight := 600;
  Top := (Screen.Height - Height) div 2;
  Left := (Screen.Width - Width) div 2;
  Image1.Width := 690;
  Image1.Height := 470;
  Bitmapd := Tbitmap.Create;
  Bitmapd.Width := Image1.Width;
  Bitmapd.Height := Image1.Height;
  Image1.Picture.Graphic := Bitmapd;
  Bitmapd.Free;
  Image1.Top := 56;
  Image1.Left := 100;
  OpenBtn.Top := 24;
  OpenBtn.Left := 8;
  OpenBtn.Width := 73;
  OpenBtn.Height := 25;
  X0 := 15;
  Y0 := 455;
  SUX := 20;                                // XP[
  S :=  10;                                 // \XP[
  GridMakeF := False;
  PaintBtn.Enabled := False;
  LineBackbtn.Enabled := False;
  EleChBtn.Enabled := False;
  ClchangeBtn.Enabled := False;
  InoutChkBtn.Enabled := False;
  Savebtn.Enabled := False;
  RedrowBtn.Enabled := False;
  EleChF := False;
  Keisu := 1;                               // \W
  Form1.Caption := '}';
  MLabel.Caption := 'Obh}邩At@COPENĂB'
end;

procedure TForm1.OpenBtnClick(Sender: TObject);
var
  I, J: Integer;
  KeyN: string;
begin
  if MousPd then exit;
  OpenDialog1.Filter := 'f[^[t@C(*.dat)|*.dat';
  if OpenDialog1.Execute then begin
    try
      AssignFile(F1, OpenDialog1.FileName);
    except
      exit;
    end;
    Reset(F1);
    Readln(F1, KeyN);
    if KeyN <>  Keyname then
      begin
        application.MessageBox('t@CႢ܂','',0);
        exit;
      end;
    Read(F1, S, SUX);                                                 // XP[ W
    Read(F1, NP, NE);                                                 // ߓ_@vf
    SetArrayLengthA;                                                  // zm A
    for I := 0 to NP - 1 do Read(F1, X[I], Y[I]);                     // ߓ_W
    for J := 0 to NE - 1 do Read(F1, IP[J, 0], IP[J, 1], IP[J, 2]);   // vfߓ_ԍ
    Read(F1, FixN, SideN);                                            // Œ_  EӐ
    SetArrayLengthB;                                                  // zm B
    if FixN > 0 then
      for I := 0 to FixN - 1 do Read(F1, IB[I], PB[I]);               // Œ_̓ǂݍ
    if SideN > 0 then
      for I := 0 to SideN - 1 do
        begin
          Read(F1, IOV[I, 0]);                                        // ӂ̐ߓ_ԍ
          Read(F1, IOV[I, 1]);                                        // ӂ̐ߓ_ԍ
          Read(F1, IOF[I]);                                           // ʏ
        end;
    CloseFile(F1);
  end;
  MainCalc;                                                           // MainvZ
  RedrowBtn.Enabled := True;                                          // ĕ\
  MLabel.Caption := '\WŁȂ傫ς܂B' + #13#10 +
                    'ҏW@\͂܂';
end;

procedure TForm1.SavebtnClick(Sender: TObject);
const
  Sp = ' ';
var
  I, J: Integer;
  K, M: integer;
begin
  SaveDialog1.Filter := 'f[^[t@C(*.dat)|*.dat';
  if SaveDialog1.Execute then begin
    SaveDialog1.FileName := ChangeFileExt(SaveDialog1.FileName, '.dat');
    if FileExists(SaveDialog1.FileName) then
        if MessageDlg('Ƀt@C݂܂㏑܂' + #13#10
              + ExtractFilename(SaveDialog1.FileName) + '?',
                  mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;
    try
      AssignFile(F1, SaveDialog1.FileName);
    except
      exit;
    end;
    ReWrite(F1);
    Writeln(F1, Keyname);          //  'UGEN';
    Writeln(F1, S, Sp, SUX);
    Writeln(F1, NP, Sp, NE);
    K := NP div 10;
    M := NP mod 10;
    for J := 0 to K - 1 do begin
      for I := 0 to 9 do Write(F1, SP, X[I + 10 * J], SP, Y[I + 10 * J]);
      Writeln(F1);
    end;
    for I := 0 to M - 1 do begin
      Write(F1, SP, X[I + 10 * K], SP, Y[I + 10 * K]);
    end;
    Writeln(F1);
    K := NE div 10;
    M := NE mod 10;
    for J := 0 to K - 1 do begin
      for I := 0 to 9 do Write(F1, Sp, Sp, IP[I + 10 * J, 0], Sp, IP[I + 10 * J, 1], Sp, IP[I + 10 * J, 2]);
      Writeln(F1);
    end;
    for I := 0 to M - 1 do begin
      Write(F1, Sp, Sp, IP[I + 10 * K, 0], Sp, IP[I + 10 * K, 1], Sp, IP[I + 10 * K, 2]);
    end;
    Writeln(F1);
    Writeln(F1, FixN, Sp, SideN);                                         // Œ_  EӐ
    if FixN > 0 then begin
      for I := 0 to FixN - 1 do Write(F1, SP, IB[I], SP, PB[I]);          // Œߓ_̏
      Writeln(F1);
    end;
    if SideN > 0 then
      for I := 0 to SideN - 1 do
        begin
          Write(F1, Sp, IOV[I, 0]);                                        // ӂ̐ߓ_ԍ
          Write(F1, Sp, IOV[I, 1]);                                        // ӂ̐ߓ_ԍ
          Write(F1, Sp, IOF[I]);                                           // ʏ
        end;
    Writeln(F1);
    closeFile(F1);
  end;
end;

end.
